#include "ControlLayer.h"

ControlLayer::~ControlLayer(){
	CC_SAFE_RELEASE(m_pKeypadDispatcher);
}

bool ControlLayer::init()
{
	if (!CCLayer::init())
		return false;

	//CCKeypadDispatcher::SharedKeypadDispatcher()->addDelegate(this);
	m_pKeypadDispatcher = new CCKeypadDispatcher();
	m_pKeypadDispatcher->addDelegate(this);

	return true;
}

#if((CC_TARGET_PLATFORM == CC_PLATFORM_WINRT) || (CC_TARGET_PLATFORM == CC_PLATFORM_WP8))
void ControlLayer::OnKeyDown(VirtualKey key)
{
	if (key == VirtualKey::Left)
	{
		KeyBoardInput::SharedInput()->inputX = -9;
	}
	else if (key == VirtualKey::Right)
	{
		KeyBoardInput::SharedInput()->inputX = 9;
	}
}
#else
void ControlLayer::keyArrowClicked(int arrow) {
	if( kTypeLeftArrowClicked == arrow){
		KeyBoardInput::SharedInput()->inputX = -9;
	}else if( kTypeRightArrowClicked == arrow){
		KeyBoardInput::SharedInput()->inputX = 9;
	}
}; 
#endif
void ControlLayer::OnKeyUp()
{
	KeyBoardInput::SharedInput()->inputX = 0;
}

void ControlLayer::setKeypadDispatcher(CCKeypadDispatcher* pKeypadDispatcher)
{
    CC_SAFE_RETAIN(pKeypadDispatcher);
    CC_SAFE_RELEASE(m_pKeypadDispatcher);
    m_pKeypadDispatcher = pKeypadDispatcher;
}

CCKeypadDispatcher* ControlLayer::getKeypadDispatcher()
{
    return m_pKeypadDispatcher;
}
